// Class automatically generated by Dev-C++ New Class wizard



#if !defined(adolc_graph_classes)
#define adolc_graph_classes 1
#include <stdlib.h>
#include <iostream> 
#include <iomanip>
#include <vector>
using namespace std;
/*
Things to do:

Overload [] on Block to get elements x[i] and w[i] ?
*/


class Block
{
  
  public:
    int max_size;
    Block();
    explicit Block(int N);
    Block(const Block& other ); //copy constructor
    ~Block();
    bool isempty() const;
    int reset_real();
    void increment(int xx, double ww);
    int  insert_end(int xx, double ww);
    int  insert_inorder(int xx, double ww);
    void push_forward(int pos);
    void push_back(int pos);    
    void grow();     void grow(const int);
    void print() const;
    int compare(Block * B, double eps) const;
    void print_line(int N,bool) const;
    void print_details() const;
    int count() const;
    int remove_end();
    int remove_first();    
    int  get_pos(int xx) const; 
    double get_lastw() const;
    int get_lastx() const;  
    double get_firstw()const;
    int get_firstx() const;      
    void reset_fixed();
    void reset();
    // private:
    int copy(const Block &);
    void Myrealloc( const int newsize);
    void Myrealloc2( const int newsize);
    void merge(const Block & B);
    void subtract_int(int factor);
    template <class VecType> const double operator*(const VecType & xvec) const{
      int i;
      double out =0;
      for(i=first_pos; i< last_pos+1; i++)
	out+= w[i]*xvec[x[i]];
      return(out);
    }   
    template <class VecType> void  transpose_mult(const VecType & vec_in,  VecType & vec_out, int piv) const{
      int i; 
      for(i=first_pos; i< last_pos+1; i++){
	 if(piv!= x[i])
	   vec_out[x[i]] +=  w[i]*vec_in[piv];
       }
    }
   // double operator*(const double * xvec);
    Block & operator+=(const double scalar);
    Block & operator*=(const double scalar);
    Block & operator+=(const Block & other);
//private:
  int *x;
  double *w;
  int initial_size, size_step, cur_size,  first_pos, last_pos, median,  balance; //nelem
};

class Graph{
  public:
    int N,  max_active;
    mutable int nz;
    Block * B;  /* The ith Block element contains the neighbor set of the ith node*/
    bool is_dense;
    bool has_max_size;
    explicit Graph(int n);
    Graph();
    Graph(const Graph & other); //copy constructor
    int initiate(int);
    ~Graph();
    int isempty();
    int remove_end(int xx);
    int remove_first(int xx);
    int free_edges(int xx);
    int free_fixed_edges( int xx);
    int subtract_int(int factor);
    void increment_edge(int big, int small, double val);
    int insert_edge(int big, int small, double val);
    int insert_edge_inorder(int big, int small, double val);
    int is_neighbor(int node, int neighbor);
    int get_dimension() const;
    int get_first_position(int blockn) const;
    int get_last_position(int blockn) const;       
    double get_last_edge_weight(int node) const;
    int get_last_neighbor(int node) const;  
    double get_first_edge_weight(int node) const;
    int get_first_neighbor(int node) const;  
    int get_neighbor_node(int node,int neighbor_position) const;       
    double get_edge_weight(int node_position,int neighbor_position) const;   
    int get_neighbor_position(int node, int neighbor ) const;
    void merge(const Graph & G);
    void print() const;
    int compare(Graph * other,  double eps) const;
    int count_nz() const;
    int count_diagonal() const;
    void reset();
    void reset_neighbors(int node);
    void replace_neighbors(int node, const Block & new_neighbors);
    int copy_neighbors(const Graph & , int from, int into);
    int copy_neighbors(const Block &, int into);
    /*Few as a matrix */
    void print_square(bool) const;
    int to_CSR(int ** I, int ** J, double ** val) const;
    int to_coordinate_arrays(int ** I, int ** J, double ** val) const;    
    //Sum two matrices
    //double * mult(const double * xvec);
    //double vector_mult(double * lhs, const double * xvec);
    template <class VecType> const VecType  operator*(const VecType & xvec) const {
      //DON'T Pass the pointer, who would delete it?
      //VecType * Matx = new VecType(N);
      VecType  Matx(N);
      int i;
      for(i=0; i<N; i++)
	Matx[i] = B[i]*xvec;
      return(Matx);
    }
    template <class VecType> void vector_mult(const VecType & vec_in, VecType & vec_out) const{
      int i;
      for(i=0; i<N; i++){
	vec_out[i] = B[i]*vec_in;
	// The symmetric counterpart 
	B[i].transpose_mult(vec_in, vec_out,i);
      }      
    }
    Graph & operator*=(const double scalar);
    Graph & operator+=(const double scalar);
    Graph & operator+=(const Graph &);
    double * operator*(const double * xvec);    
    //Graph& operator*( const double alpha);
    //Multiply by a constant
    //Multiply be a vector
};

int binarySearch(int * x, int first, int last, int key);
void reuse_graph(Graph ** G, int max_active);
#endif

