// Class automatically generated by Dev-C++ New Class wizard
#include <adolc/highorder/graph_blocks.h> // class's header file

Block::Block(int n)
: initial_size(2),
size_step(2),
cur_size(4),
first_pos(0),
last_pos(-1),
max_size(n),
median(-1),
balance(0)
{
  //cout<<"Block constructor"<<endl;
  /*initial_size = 2;
   *  size_step = 2;
   *  cur_size = 2;    
   *  first_pos =0;
   *  last_pos =-1;
   *  max_size = n;
   *  median =-1;
   *  balance =0; //*/
   x = (int *) malloc(sizeof(int) * cur_size);
   w = (double *) malloc(sizeof(double) * cur_size);
   //nelem = 0;
}
Block::Block()
: initial_size(2),
size_step(2),
cur_size(4),
first_pos(0),
last_pos(-1),
max_size(-1),
median(-1),
balance(0){
  // initial_size = 2;
 /* size_step = 2;
  cur_size = 4;    
  max_size = -1;
  first_pos =0;
  last_pos =-1;
  median =-1;
  balance =0; */   
  x = (int *) malloc(sizeof(int) * cur_size);
  w = (double *) malloc(sizeof(double) * cur_size);
}
Block::Block(const Block& other){
 // cout<<"Block Copy Constructor!"<<endl;
  copy(other);
}
bool Block::isempty() const{
  if(last_pos ==-1)
    return 1;
  else
    return 0;
}

int Graph::isempty(){
  int tot;
  for(int i =0; i<N; i++) 
    tot +=B[i].isempty();
 return(tot);
}

void Block::reset(){
  
  first_pos = cur_size/3;
  last_pos =-1;
  median =-1;
  balance =0;    
  // nelem = 0;
}
void Graph::reset(){
  int i;  
  for(i=0; i<max_active; i++){   
    B[i].reset();
  } 
  is_dense=0;
  has_max_size =0;
  nz =0;
}
void Graph::reset_neighbors(int node){
  int i;  
  if(node < N)
    B[node].reset();
  else
    cout<<"Node not in Graph! Cannot reset!"<<endl;
}
Block::~Block(){
  initial_size = 0;
  size_step = 0;
  cur_size = 0;    
  max_size = 0;   
  // nelem = 0;    
  first_pos =0;
  last_pos -1;
  median =-1;
  balance =0;   
  if(w!=NULL)
    free(w);
  if(x!=NULL)
    free(x);
  
  w = NULL;
  x = NULL;
}
void Graph::replace_neighbors(int node, const Block & new_neighbors){
  
 // if(B[node].isempty() ==0 ){
    //free(B[node].x);    
    //free(B[node].w);
 // }
  B[node].copy(new_neighbors);
// if(B[node].x!=NULL)
//    free(B[node].x);
 // if(B[node].w!=NULL)
 //   free(B[node].w);//*/
 // B[node] = *new_neighbors;
}
void Block::reset_fixed(){
  //cout<<"Block constructor"<<endl;
  first_pos = 0;
  last_pos =-1;
  median =-1;
  balance =0;    
  // nelem = 0;
}
int Block::reset_real(){
  first_pos = 0;
  last_pos =-1;
  median =-1;
  size_step = 2;
  cur_size = 4;  
  balance =0;   
  if(w!=NULL)
    free(w);
  if(x!=NULL)
    free(x);  
  x = (int *) malloc(sizeof(int) * cur_size);
  // cout<<"x?"<<endl;
  w = (double *) malloc(sizeof(double) * cur_size);
}
void Block::Myrealloc(const int newsize){
  int i;
  // cout<<"Myrealloc"<<endl;
  int nelem = (last_pos-first_pos)+1;
  if(last_pos==-1)
    nelem =0;
  
  //cout<<"newsize: "<<newsize<<" nelem: "<<nelem<<endl;
  int available = newsize-nelem; 
  cur_size = newsize;
  // cout<<"first: "<<first_pos<<" last:"<<last_pos<<" available  "<<available<<endl; 
  // cout<<"x first: "<<x[first_pos]<<" xlast:"<<x[last_pos]<<endl;  
  // if(available > 2*x[first_pos])
  //   available = 2*x[first_pos];
  
  //It rounds DOWN integer divisions
  int last_pos1 = available/2 + nelem-1;
  int first_pos1 = available/2;
  
  if(median!=-1) { 
    //  cout<<"old median: "<<median<<" new median: "<< median + (available/2 - first_pos)<<endl;
    median =  median + (available/2 - first_pos);
    
  }
  // cout<<"first1: "<<first_pos1<<" last1:"<<last_pos1<<endl;
  
  x = (int *) realloc(x,sizeof(int) * cur_size);
  w = (double *) realloc(w,sizeof(double) * cur_size); 
  if(x==NULL || w==NULL){
    cout<<"Myrealloc FAILED"<<endl;
  }
  if(available!=0 && first_pos1!= first_pos )  {
    for(i=nelem-1; i>=0; i--){
      //    cout<<"copying  ("<<i+first_pos<<",x="<<x[i+first_pos]<<")  to  pos "<<i+first_pos1<<endl;
      x[i+first_pos1] = x[i+first_pos];
      w[i+first_pos1] = w[i+first_pos];
      x[i+first_pos] = 0;
      w[i+first_pos] =0;
    }
  }
  if(last_pos!=-1)  
    last_pos = last_pos1;
  first_pos = first_pos1;
  // print();
  //cout<<"end Myrealloc"<<endl;
}
 void Block::Myrealloc2(const int newsize){
  int i;
  // cout<<"Myrealloc"<<endl;
  cur_size = newsize;
  x = (int *) realloc(x,sizeof(int) * cur_size);
  w = (double *) realloc(w,sizeof(double) * cur_size); 
  if(x==NULL || w==NULL)
    cout<<"Myrealloc2 FAILED"<<endl;
}
Graph::Graph(int n):
is_dense(0),
has_max_size(0),
max_active(n),
N(n),
nz(0)
{    
  B = new Block [n];
}

Graph::Graph(const Graph& other):
N(other.N),
is_dense(other.is_dense),
has_max_size(other.has_max_size),
max_active(other.max_active),
nz(other.nz)
{
 // cout<<"Copy Constructor: allocating a graph with "<<other.N<<" nodes"<<endl;
  B = new Block [N];
  for(int i =0; i< N; i++)
    B[i].copy(other.B[i]);
}
int  Graph::initiate(int n){    
  int i; 
  B = new Block [n];
  is_dense=0;
  has_max_size =0;
  N =n;
  nz =0;
}       
Graph::Graph():
N(0),
nz(0),
B(NULL)
{    
  //cout<<"Graph contructor with empty stuff"<<N<<", "<<max_active<<endl;
}      

Graph::~Graph(){
  //cout<<"Graph destructor of size n, max_ative "<<N<<", "<<max_active<<endl;
  if(B!= NULL)
    delete [] B; 
}
double Block::get_lastw() const{
  if(last_pos==-1)
    return(-1);
  return(w[last_pos]);
  
}
int Block::get_lastx() const{      
  if(last_pos==-1)
    return(-1);
  return(x[last_pos]);
}
double Block::get_firstw() const{
  if(last_pos==-1)
    return(-1);
  return(w[first_pos]);
}
int Block::get_firstx() const{      
  if(last_pos==-1)
    return(-1);
  return(x[first_pos]);
}
int Block::remove_end(){
  int temp;
  if(last_pos>-1){  
    temp =last_pos;
    if(last_pos==first_pos)
      last_pos=-1;
    else
      last_pos--; 
    
    balance--;//
    if(balance<-1){
      median--;
      balance=0;
    }
    
    return(temp);
  }
  else{
    return(-1);   
  }
}
int Block::remove_first(){
  if(last_pos==-1)
    return(0);
  else if(first_pos==last_pos){
    last_pos =-1;
    median =-1;
  }
  else
    first_pos++;
  return(1);
}
int Graph::remove_end(int xx){
  return(B[xx].remove_end() );
} 
int Graph::remove_first(int xx){
  return(B[xx].remove_first() );
}   
void Block::increment(int xx, double ww) {
  int p;
  p = get_pos(xx);
  if (p<0) {
    p = insert_end(xx, ww);
  } else {
    w[p] += ww;
    
  }
}
int Graph::free_edges(int xx){
  int temp;
  //cout<<"freeing: "<<xx;
  temp = B[xx].last_pos;
  // cout<<"  last_pos: "<<B[xx].last_pos<<endl;
  B[xx].reset();
  // B[xx].last_pos =-1;
  return (temp);
} 
int Graph::free_fixed_edges(int xx){
  int temp;
  //  cout<<"freeing: "<<xx;
  temp = B[xx].last_pos;
  //  cout<<"  last_pos: "<<B[xx].last_pos<<endl;
  B[xx].reset_fixed();
  // B[xx].last_pos =-1;
  return (temp);
} 
void Graph::increment_edge(int big, int small, double val){
  
  
  if(big > N || big <0){
    cout<<"Node "<<big<<" doesn't in graph"<<endl;
    return;
  }
  B[big].increment(small, val);
  // B[big].nelem++;
}
int Block::insert_end(int xx, double ww) {
  //cout<<"cur_size: "<<cur_size<<"  nelem "<<nelem<<endl;
  if(cur_size == last_pos+1)
    Myrealloc2(cur_size*size_step);
  // grow();
  last_pos++;	
  w[last_pos] = ww;
  x[last_pos] = xx;
  //  cout<<"insert_end  new last_pos "<<last_pos<<"   " ;
  //  cout<<"w[last_pos]: "<<w[last_pos]<<"  x[last_pos] "<<x[last_pos]<<endl;     
  //cout<<"ww: "<<ww<<"  xx "<<xx<<endl;
  return(last_pos);
}
int Block::insert_inorder(int xx, double ww) {
  int i,j, temp;
  //print_details();
  //----Finding position---//
  if(last_pos==-1){
    //cout<<"empty  with first: "<<first_pos<<" last:"<<last_pos<<endl;
    if(x==NULL || w==NULL)
      cout<<"some one NULL"<<endl;
    x[first_pos] = xx;
    w[first_pos] = ww;
    last_pos =first_pos;
    median = first_pos;
    balance =0;
    //insert_end(xx, ww);
    return(1);
  }
  else {  
    j= binarySearch(x, first_pos, last_pos, xx);
  }
  //----Using position---//

  
  if(x[j]==xx){
    w[j]+=ww;
    //cout<<"found: "<<x[j]<<" at pos "<<j<<endl;
    return(j);
  }   
  //*/
  if(xx < x[median]){
    temp = first_pos;
    if(x[j]< xx){
      j++;
    }
    if(first_pos==0){
      grow();
      j = j + (first_pos-temp);
    }
    if(j!= first_pos)  
      push_back(j-1);  
    x[j-1] =xx;
    w[j-1] =ww;
    first_pos--;
    balance--;
    if(last_pos==-1){
      last_pos=first_pos;
      median = first_pos;
    }
    else if(balance<-1){
      median--;
      balance =0;
    }
       // cout<<"fin  with first: "<<first_pos<<" last:"<<last_pos<<endl;
     //   cout<<"finnished before median: "<<median<<"  with balance: "<<balance<<endl;
     //print_details();
  return(j-1);
}
temp = last_pos;
//    cout<<"after median: "<<median<<"  with balance: "<<balance<<endl;
balance++;
if(x[j]< xx){
  j++;
  //        cout<<"j++: "<<j<<endl;
}
//cout<<"j: "<<j<<" last_pos+1  "<<last_pos+1<<endl;
if(cur_size == last_pos +1){
  grow();
  j = j + (last_pos-temp);
}
if(last_pos+1!=j)   
  push_forward(j);
//DONT FORGET YOU CAN PUSH_BACKWARD AS WELL!

// if(cur_size == last_pos +1)
//      grow();
w[j] = ww;
x[j] = xx;
last_pos++;
if(last_pos==first_pos){
  median = first_pos;
}
else if(balance>1){
  median++;
  balance =0;
}
//   cout<<"fin Block  with first: "<<first_pos<<" last:"<<last_pos<<endl;   
//   cout<<"finished after median: "<<median<<"  with balance: "<<balance<<endl; 
return(-1);
}  
void Block::push_forward(int pos){
  int i;
  //  cout<<"pushing forward: "<<pos<<endl;
  if(last_pos+2 > cur_size){
    cout<<"block not big enough for push_forwad"<<endl;
    return;
  }
  for(i=last_pos+1; i>pos; i--){
    x[i] =x[i-1];
    w[i] = w[i-1];
  }
}
void Block::push_back(int pos){
  int i;
  //   cout<<"pushing back: "<<pos<<endl;
  if(first_pos ==0){
    cout<<"block not big enough for push_back"<<endl;
    return;
  }
  for(i=first_pos-1; i<pos; i++){
    x[i] =x[i+1];
    w[i] = w[i+1];
  }
} 
int Graph::insert_edge_inorder(int big,int small, double ww){
  int temp,i;  
  temp =B[big].insert_inorder(small, ww);
  return(temp);
}
int Graph::get_dimension() const{
  return(N); 
}
int Graph::get_first_position(int node) const{
  return(B[node].first_pos);
}
int Graph::get_last_position(int node) const{
  return(B[node].last_pos);
}
int Graph::get_neighbor_node(int node,int neighbor_position) const{
  return(B[node].x[neighbor_position]);
}
double Graph::get_edge_weight(int node,int neighbor_position) const{
  return(B[node].w[neighbor_position]);
}
int Graph::get_neighbor_position(int node, int neighbor ) const{
  int temp =B[node].get_pos(neighbor);
  if(temp ==-1)
    return(-1);
  else if( get_neighbor_node( node,temp)!= neighbor ){
    return(-1);
  }
  return(temp);
}
double Graph::get_last_edge_weight(int node) const{
  return(B[node].get_lastw());
}
int Graph::get_last_neighbor(int node) const{
  return(B[node].get_lastx());
}
double Graph::get_first_edge_weight(int node) const{
  return(B[node].get_firstw());
}
int Graph::get_first_neighbor(int node) const{
  return(B[node].get_firstx());
}
int Graph::insert_edge(int big, int small, double val){
  // cout<<"insert_edge: "<<big<<" , "<<small<<endl;
  if(has_max_size){
    if(big > N || big <0){
      cout<<"Node "<<big<<" doesn't exist in graph"<<endl;
      return -1;
    }
  }
  //   cout<<"inserting: "<<small<<" in "<<big<<endl; 
  B[big].insert_end(small,val);
  
}
void Block::grow() {
  //cout<<"grow Block"<<endl;
  //  cout<<"size: "<<cur_size<<" with step: "<<size_step;
  cur_size = size_step*cur_size;
  //  cout<<"  growing to new size: "<<cur_size<<endl;
  
  if(max_size!=-1 && cur_size> max_size){
    cout<<" hit maxsize "<<max_size<<endl;
    cur_size= max_size;
  }
  
  Myrealloc(cur_size);
  //x = (int *) realloc(x, sizeof(int) * cur_size);
  // w = (double *) realloc(w, sizeof(double) * cur_size);
}
void Block::grow(const int size) {
  //cout<<"grow Block size: "<<size<<endl;
  cur_size = size;
  Myrealloc(cur_size);
  //x = (int *) realloc(x, sizeof(int) * cur_size);
  //w = (double *) realloc(w, sizeof(double) * cur_size);
}
int Block::copy(const Block & B){
  int i;
 last_pos = B.last_pos;
 first_pos = B.first_pos;  
 int nelem = last_pos - first_pos+1;
 cur_size = B.cur_size; 
 initial_size = B.initial_size;
 size_step = B.size_step;
 
 if(B.cur_size > cur_size){
   x = (int *) realloc(x,sizeof(int) * cur_size);
   w = (double *) realloc(w,sizeof(double) * B.cur_size); 
 }

 for(i= first_pos; i< last_pos+1; i++){
   x[i] = B.x[i];
   w[i] = B.w[i];
 }
 return(nelem);   
 
}

int Graph::copy_neighbors(const Graph & G, int from, int into){
  int i;
  B[into].copy( G.B[from]);
  
}  
int Graph::copy_neighbors(const Block & B1, int into){
  int i;
  
  B[into].copy(B1);
  
}  
int Block::get_pos(int node) const{
  int i;
  //binary search
  if(last_pos==first_pos)
    i=last_pos;
  else if(last_pos==-1)
    i=-1;
  else {  
    // cout<<"first, last: "<<x[0]<<", "<<x[nelem-1]<<endl;
    i =binarySearch(x, first_pos, last_pos, node);
  }
  return i;
}

int binarySearch(int * x, int first, int last, int key) {
  int mid;
  // cout<<"start binary"<<endl;
  // 	        cout<<"first, mid,  last: "<<first<<", "<<mid<<" , "<<last<<endl;
  while (first <= last) {
    mid = (first + last) / 2;  // compute mid point.
    //cout<<"mid: "<<mid<<endl;
    if (key > x[mid]){ 
      //      cout<<"first, mid,  last: "<<first<<", "<<mid<<" , "<<last<<endl;
      first = mid + 1;  // repeat search in top half.
    }
    else if (key < x[mid]){
      //        cout<<"first, mid,  last: "<<first<<", "<<mid<<" , "<<last<<endl;
      last = mid - 1; // repeat search in bottom half.
    }
    else
      return mid;     // found it. return position /////
  }
  return mid;    // failed to find key
}
void reuse_graph(Graph ** G, int max_active){
  if((*G)==NULL){
    *G = new Graph (max_active);
  }
  else if((*G)->max_active != max_active){
    cout<<"re-using the wrong size graph with "<<(*G)->max_active<<" nodes! Allocating again"<<endl;
    delete(*G);
    *G = new Graph (max_active);    
    (*G)->N = max_active; 
    (*G)->reset();
  } 
  else{
    (*G)->N = max_active; 
    (*G)->reset();    
  }
}
void Block::merge(const Block & B){
  int i,j,k;
  int xj, xk, lastj, lastk;
  double wj,wk;
  Block *tempB(this);
  
  //tempB.copy(this);
  
  j =B.first_pos;
  lastj = B.last_pos;
  
  k =tempB->first_pos;
  lastk = tempB->last_pos;
  
  i=0;
  first_pos =0;
  
  while( j<= lastj && k <= lastk){
    xj = B.x[j];
    xk = tempB->x[k];
    wj = B.w[j];
    wk = tempB->w[k];      
    //cout<<"i ,j ,k  "<<i<<" ,"<<j<<" ,"<<k<<"  xj, xk "<<xj<<", "<<xk<<endl; 
    if(i == cur_size)
      Myrealloc2(cur_size*size_step);
    
    if(xj<xk){
      x[i] = xj;
      w[i] = wj;
      i++;
      j++;
    }	 
    else if( xj ==xk){
      x[i] = xj;
      w[i] = wj+wk;
      i++;
      j++;
      k++;
    }
    else{
      x[i] = xk;
      w[i] = wk;
      i++;
      k++;
    }	 
  }
  
  while(j <= lastj){
    if(i == cur_size)
      Myrealloc2(cur_size*size_step);
    x[i] =  B.x[j];
    w[i] =  B.w[j];   
    i++;
    j++; 
  }
  while(k <= lastk){
    if(i == cur_size)
      Myrealloc2(cur_size*size_step);
    x[i] =  tempB->x[k];
    w[i] =  tempB->w[k];   
    i++;
    k++; 
  }
  //cout<<"at very end i ,j ,k  "<<i<<" ,"<<j<<" ,"<<k<<"  xj, xk "<<xj<<", "<<xk<<endl; 
  last_pos = i-1;
}
void Graph::merge(const Graph & G){
  int i,minN;
  if(N<G.N){  
    minN=N;
    //cout<<"not compatible Graph for Merger"<<endl;
  }
  else
    minN = G.N;
  for(i=0; i<minN;i++){
    B[i].merge(G.B[i]);  
  }
}
void Block::print() const{
  int i;
  //cout<<"Block print with first: "<<first_pos<<" last:"<<last_pos<<endl;
  for(i=first_pos; i< last_pos+1; i++)
    cout<<"("<<x[i]<<","<<w[i]<<") ";
  cout<<endl;
}
int Block::compare(Block * Bin, double eps) const{
  int i, get_out;
  //print_details();
  for(i=first_pos; i< last_pos+1; i++){
    if(Bin->last_pos <0){
      cout<<"Empty neighbors! Different from this one"<<endl;
      return(1);
    }
    get_out = Bin->get_pos(x[i]); 
    if(get_out <0){
      cout<<x[i]<<" not in neighbors!"<<endl;
      return 1;
    }
    else if(Bin->x[get_out] !=x[i] ){
      //cout<<"i: "<<i<<"  get_out  "<<get_out<<" x[get_out]  "<< Bin->x[get_out]<<endl;
      cout<<x[i]<<" not in neighbors!"<<endl;
      return 1;
    }
    else if((Bin->w[get_out]-w[i])/w[i]>eps || (Bin->w[get_out]-w[i])/w[i]<-eps){
    cout<<" Position "<<x[i]<<" has a "<<(Bin->w[get_out]-w[i])/w[i]<<
    "% difference in edge weights "<<w[i]<<" X "<< Bin->w[get_out]<<endl;
      return 1;
    }
    //cout<<" Position "<<x[i]<<" has a "<<(Bin.w[get_out]-w[i])<<" difference in edge weights "<<w[i]<<" X "<< Bin.w[get_out]<<endl;
    //cout<<"Both Blocks have: ("<<x[i]<<","<<w[i]<<") "<<endl;
  }
  return 0;
}

void Block::print_details() const{
  int i;
  cout<<"Block print with first: "<<first_pos<<" last:"<<last_pos<<endl;
  cout<<"median: "<<median<<" balance: "<<balance<<endl;
  
  for(i=first_pos; i< last_pos+1; i++)
    cout<<"("<<x[i]<<","<<w[i]<<") ";
  cout<<endl;
}
int Block::count() const{
  int i;
  int count =0;
  if(last_pos+1> first_pos)
    count=last_pos+1 -first_pos;
  
  return(count);
  
}
void Block::print_line(int N,bool sparsity) const{
  int i,k;
  cout<<setprecision(4);
  cout<<scientific;
  k = first_pos;
  if(sparsity){
    for(i=0; i<N; i++){
      if(x[k]==i && k <last_pos +1){
	cout<<"X"<<"  ";
	k++;
      }
      else{ 
	cout<<"   ";
      }
      
    }
    
  }
  else
  {
    for(i=0; i<N; i++){
      if(x[k]==i && k <last_pos +1){
	cout<<w[k]<<"\t";
	k++;
      }
      else{ 
	cout<<"         \t";
      }
      
    }
  }
  cout<<endl;
}
void Block::subtract_int(int factor){
  int j;
  for(j=first_pos; j< last_pos+1; j++)
    x[j] = x[j] -factor;
}
/*template <class VecType> double Block::operator*(const VecType & xvec){
  int i;
  double out =0;
    for(i=first_pos; i< last_pos+1; i++)
       out+= w[i]*xvec[x[i]];
 return(out);
} 
template double Block::operator*<double>(const double  * xvec); //*/
/*double Block::operator*(const double * xvec){
  int i;
  double out =0;
    for(i=first_pos; i< last_pos+1; i++)
       out+= w[i]*xvec[x[i]];
 return(out);
}//*/
Block & Block::operator+=(const double scalar){
  int i;
  double out =0;
    for(i=first_pos; i< last_pos+1; i++)
       w[i] += scalar;
 return(*this);
} 
Block & Block::operator*=(const double scalar){
  int i;
  double out =0;
    for(i=first_pos; i< last_pos+1; i++)
       w[i] *= scalar;
 return(*this);
} 
Block & Block::operator+=(const Block & other){
  int i,oi;
  int ofirst_pos =other.first_pos;
  int olast_pos = other.last_pos;
  i = first_pos;
  oi= ofirst_pos;  
  while( i<= last_pos && oi <= olast_pos){
    if(x[i]< other.x[oi]){
      i++;
    }	 
    else if( x[i] ==other.x[oi]){
      w[i] += other.w[oi];
      i++;
      oi++;
    }
    else{
      oi++;
    }	 
  }
  while(oi <= olast_pos){
    if(i == cur_size)
      grow();
    x[i] =  other.x[oi];
    w[i] =  other.w[oi];   
    i++;
    oi++; 
  }
   return(*this);
} 
int Graph::subtract_int(int factor){
  int i,j;
  for(i=0; i<N; i++)
    B[i].subtract_int(factor);
} 
void Graph::print() const{
  int i,j;
  setprecision(4);
  // cout<<scientific;
  setw(5);
  cout<<"Graph with "<<N<<" nodes "<<endl;
  
  for(i=0; i<N; i++){
    if(N>9)
      cout<<i<<": ";
    else
      cout<<i<<" : ";     
    B[i].print();
  }
  
}
int Graph::compare(Graph * Gin, double eps) const{
   int i;
   int tot =0;
   if(Gin->N != N){
     cout<<"Graphs of different size! "<<N<<" X "<<Gin->N<<endl;
     return(0);
   }
   for (i=0; i<N; i++){
     //cout<<"Block:"<<i<<endl;
     tot += B[i].compare(&(Gin->B[i]), eps);
   }
   if(tot ==0)
     cout<<"Identical Graphs!"<<endl;
   else
     cout<<"Graph differ in "<<tot<<" number of Blocks"<<endl;
   return(tot);
}
void Graph::print_square(bool sparsity) const{
  int i,j;
  if(B==NULL){
    cout<<"NULL GRAPH"<<endl;
    return;
  }
  setprecision(4);
  // cout<<scientific;
  setw(5);
  cout<<"Graph with ";
  cout<<N<<" nodes "<<endl;
  
  for(i=0; i<N; i++){
    if(i>9)
      cout<<i<<": ";
    else
      cout<<i<<" : ";   
    B[i].print_line(N,sparsity);
  }  
  
}
int Graph::count_nz() const{ 
  nz =0;
  int i;
  for(i =0; i<N; i++)
    nz += B[i].count();
  return(nz);
}
int Graph::count_diagonal() const{ 
  int diag =0;
  int get_diag =0;
  int i;
  for(i =0; i<N; i++){
     get_diag=get_neighbor_position(i,i); 
     if(get_diag !=-1)
       diag++;
  }
  return(diag);
}
int Graph::to_CSR(int ** rowindex, int ** columns, double ** val) const{
  /*
   * This symmetric CSR format is described as in the Intel MKL reference manual. Specifically
   * with calls to functions mkl_csrsymv and dcsrilu0 in mind
   */
  
  int k=0;
  int first, last;
  int  i,j;
  bool has_diag =0;
  int zero_diag = N -count_diagonal();
  int CSR_size = count_nz() + zero_diag;
  //cout<<"CSR_size: "<<CSR_size<<endl;
  //allocating//
  if((*rowindex)==NULL) (*rowindex) = new int [N+1];
  if((*columns)==NULL) (*columns) = new int [CSR_size];
  if((*val)==NULL) (*val) = new double [CSR_size];
  (*rowindex)[N] = CSR_size; // Last element contain number of nonzeros
  for(i =0; i<N; i++){ //cout<<"i: "<<i<<endl;
    has_diag = 0;
    if(k> CSR_size){  cout<<"Too many nonzero! wrong size"<<endl; return(-1);  }
    first = B[i].first_pos;
    last = B[i].last_pos;
    (*rowindex)[i] = k+1;    
    for(j =first; j<last+1; j++){ 
     /* cout<<"k "<<k<<endl;
      cout<<"B[i].x[j] "<<B[i].x[j]<<endl;
      cout<<"has_diag "<<has_diag<<endl; */
     (*columns)[k] = B[i].x[j]+1;
     (*val)[k] = B[i].w[j];
     k++;
      if(B[i].x[j] ==i)
	has_diag =1;
    }
    if(has_diag ==0){ // adding a zero element for diagonal
      //cout<<"forcing diagonal"<<endl;
      (*columns)[k] = i+1;
      (*val)[k] = 0.0;
      k++;
    }
    
    
  }
 // cout<<"finished transform"<<endl;
  return(CSR_size);
}

int Graph::to_coordinate_arrays(int ** rows, int ** columns, double ** val) const{
 /*
 * This is a Coordinate list (COO) format. 
 COO stores a list of (row, column, value) tuples. The entries are sorted by (row index, then column index)
   */
  int k=0;
  int first, last;
  int  i,j;
  bool has_diag =0;
  int zero_diag = N -count_diagonal();
  int COO_size = count_nz() + zero_diag;
  //cout<<"COO_size: "<<COO_size<<endl;
  //allocating//
  if((*rows)==NULL) (*rows) = new int [COO_size];
  if((*columns)==NULL) (*columns) = new int [COO_size];
  if((*val)==NULL) (*val) = new double [COO_size];
  
  for(i =0; i<N; i++){ 
    has_diag = 0;
    if(k> COO_size){  cout<<"Too many nonzero! wrong size"<<endl; return(-1);  }
    first = B[i].first_pos;
    last = B[i].last_pos;
    for(j =first; j<last+1; j++){ 
     // cout<<"k "<<k<<endl;
     // cout<<"B[i].x[j] "<<B[i].x[j]<<endl;
      //cout<<"has_diag "<<has_diag<<endl;
      (*rows)[k] = i+1;
      (*columns)[k] = B[i].x[j]+1;
      (*val)[k] = B[i].w[j];
      k++;
      if(B[i].x[j] ==i)
	has_diag =1;
    }
    if(has_diag ==0){ // adding a zero element for diagonal
      //cout<<"forcing diagonal"<<endl;
      (*columns)[k] = i+1;
      (*rows)[k] = i+1;
      (*val)[k] = 0.0;
      k++;
    }
  }
  //cout<<"finished transform"<<endl;
  return(COO_size);
}

/*double Graph::vector_mult(double * lhs, const double * xvec){
  int i;
  for(i=0; i<N; i++)
    lhs[i] = B[i]*xvec;
  return(1);
}//*/
/*double * Graph::operator*(const double* xvec){
  double * Matx = new double [N];
  int i;
  for(i=0; i<N; i++)
    Matx[i] = B[i]*xvec;
  return(Matx);
}//*/
Graph & Graph::operator*=(const double scalar){
  int i;
  for(i=0; i<N; i++)
     B[i]*= scalar;
  return(*this);
}
Graph & Graph::operator+=(const double scalar){
  int i;
  for(i=0; i<N; i++)
     B[i]+= scalar;
  return(*this);
}
Graph & Graph::operator+=(const Graph & other){
  int i;
  for(i=0; i<N; i++)
     B[i]+= other.B[i];
  return *this;
}    
