#include <unistd.h>
#include <ios>
#include <fstream>
#include <stdio.h>
#include <math.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/resource.h>
#include <ctime>
#include "../function_input.h"
#include <iomanip>
#include <adolc/adolc.h>
using namespace std;

void process_mem_usage(double& vm_usage, double& resident_set);

int main()
{
  int  N,M;	int i,j,k,nz, num_repeats;
  int tape_num =1;
  cout<<"Dimension?"<<endl;
  cin>>N;
  /* ---------------------------------------*/
  //----------------------------------------*/
  // Variables associated to function calculation and the functions tape!
  /*--------------------------------------------------------------------------*/
  adouble yp;
  double y;
  adouble * xp;
  double * x;
  double * direction;
  x = new double [N]; 
  direction = new double [N]; 
  xp = new adouble [N];
  
  for(j=0; j<N; j++){
    x[j] =   1.0+double(2.0*j);
    direction[j] = 1;
  }
  
  trace_on(tape_num);
  for(i=0; i<N ;i++) 
    xp[i] <<= x[i];				  // active independs        //    
  yp = morebv(xp, N);
  yp >>= y;
  trace_off();
  
  Graph *Td;
  Graph * HG;
  HG = NULL;
  Td= NULL; 
  
  double vm, rss;
  num_repeats = 100;
  for(i=0; i<num_repeats; i++ ){ //NUM_FUNCS
    process_mem_usage(vm, rss);
    cout << "VM: " << vm << "; RSS: " << rss << endl;
    reverse_tensorv( tape_num,  x,  &HG, &Td,  N, direction,NULL);
  }//*/
  
  delete [] x;
  delete [] xp;
  delete [] direction;
  delete Td;
  delete HG;
  return 0;
  
  }
  void process_mem_usage(double& vm_usage, double& resident_set)
  {
    using std::ios_base;
    using std::ifstream;
    using std::string;
    
    vm_usage     = 0.0;
    resident_set = 0.0;
    
    // 'file' stat seems to give the most reliable results
    //
    ifstream stat_stream("/proc/self/stat",ios_base::in);
    
    // dummy vars for leading entries in stat that we don't care about
    //
    string pid, comm, state, ppid, pgrp, session, tty_nr;
    string tpgid, flags, minflt, cminflt, majflt, cmajflt;
    string utime, stime, cutime, cstime, priority, nice;
    string O, itrealvalue, starttime;
    
    // the two fields we want
    //
    unsigned long vsize;
    long rss;
    
    stat_stream >> pid >> comm >> state >> ppid >> pgrp >> session >> tty_nr
    >> tpgid >> flags >> minflt >> cminflt >> majflt >> cmajflt
    >> utime >> stime >> cutime >> cstime >> priority >> nice
    >> O >> itrealvalue >> starttime >> vsize >> rss; // don't care about the rest
    
    stat_stream.close();
    
    long page_size_kb = sysconf(_SC_PAGE_SIZE) / 1024; // in case x86-64 is configured to use 2MB pages
    vm_usage     = vsize / 1024.0;
    resident_set = rss * page_size_kb;
  }